//*****************************************************************************
//*
//*
//*		LabelCtrlDlg.cpp
//*
//*
//*****************************************************************************
// LabelCtrlDlg.cpp : Implementierungsdatei
//
#include	"StdAfx.h"
#include	"LabelCtrlApp.h"
#include	"LabelCtrlDlg.h"

#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif


#define 	 IDC_LABEL	0x1000
#define 	 IDC_LIST	0x1001
#define 	 IDC_TREE	0x1002
#define 	 IDC_EDIT	0x1003


BEGIN_MESSAGE_MAP(CLabelCtrlDlg, CDialog)
	//{{AFX_MSG_MAP(CLabelCtrlDlg)
	ON_WM_PAINT()
	ON_WM_DRAWITEM()
	ON_WM_SYSCOMMAND()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CHECK1, OnCheck1)
	ON_BN_CLICKED(IDC_CHECK2, OnCheck2)
	ON_BN_CLICKED(IDC_CHECK3, OnCheck3)
	ON_BN_CLICKED(IDC_CHECK4, OnCheck4)
	ON_BN_CLICKED(IDC_CHECK5, OnCheck5)
	ON_BN_CLICKED(IDC_CHECK6, OnCheck6)
	ON_BN_CLICKED(IDC_CHECK7, OnCheck7)
	ON_BN_CLICKED(IDC_CHECK8, OnCheck8)
	ON_BN_CLICKED(IDC_RADIO1, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO2, OnRadio2)
	ON_BN_CLICKED(IDC_RADIO3, OnRadio3)
	ON_CBN_SELCHANGE(IDC_COMBO1, OnChangeColor1)
	ON_CBN_SELCHANGE(IDC_COMBO2, OnChangeColor2)
	//}}AFX_MSG_MAP
	ON_NOTIFY(CLW_SELCHANDED,IDC_LABEL,OnSelChanged)
END_MESSAGE_MAP()


#define 	ENTRIES(a)	(sizeof(a)/sizeof(a[0]))

int			iComboIds[] =	{
							IDC_COMBO1,
							IDC_COMBO2,
							};

COLORREF	aColors[]= 		{	
							0xFFFFFFFF,
							RGB(0,0,0),
							RGB(255,0,0),
							RGB(0,255,0),
							RGB(0,0,255),
							RGB(255,255,0),
							RGB(255,0,255),
							RGB(0,255,255),
							RGB(128,128,128),
							RGB(255,128,128),
							RGB(128,255,128),
							RGB(128,128,255),
							RGB(255,255,128),
							RGB(255,128,255),
							RGB(128,255,255),
							RGB(192,192,192),
							RGB(255,192,192),
							RGB(192,255,192),
							RGB(192,192,255),
							RGB(255,255,192),
							RGB(255,192,255),
							RGB(192,255,255),
							RGB(255,255,255),
							};


//*****************************************************************************
//*
//*		CDialog
//*
//*****************************************************************************
//  CLabelCtrlDlg Dialogfeld
CLabelCtrlDlg::CLabelCtrlDlg(CWnd *pParent): CDialog(CLabelCtrlDlg::IDD,pParent)
{
	//{{AFX_DATA_INIT(CLabelCtrlDlg)
	m_iSelected = 0;
	//}}AFX_DATA_INIT
	m_hIcon		= AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_dwFlags	= CLW_FRAMETOP|CLW_CHILDSCROLL|CLW_CHILDSCROLLOFF|CLW_WHITELINE;
}

//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void CLabelCtrlDlg::DoDataExchange(CDataExchange *pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLabelCtrlDlg)
	DDX_Radio(pDX, IDC_RADIO1, m_iSelected);
	//}}AFX_DATA_MAP
}

//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
//  CLabelCtrlDlg Nachrichten-Handler
BOOL CLabelCtrlDlg::OnInitDialog()
{
HTREEITEM	hTreeItem;
CMenu	   *pSysMenu;
CRect		sRect;
int			iPos;
int			i,j;


	CDialog::OnInitDialog();


	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT( IDM_ABOUTBOX < 0xF000);



	   pSysMenu = GetSystemMenu(FALSE);
	if(pSysMenu!=NULL)
		{
		CString		sAboutMenu;

		sAboutMenu.LoadString(IDS_ABOUTBOX);
		if(!sAboutMenu.IsEmpty())
			{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, sAboutMenu);
			}
		}

	SetIcon(m_hIcon,TRUE );
	SetIcon(m_hIcon,FALSE);

	m_cImages  .Create(IDB_IMAGES,16,8,RGB(0,255,255));

	for(i=0;i<ENTRIES(iComboIds);i++)
		{
		for(j=0;j<ENTRIES(aColors);j++)
			{
			((CComboBox*)GetDlgItem(iComboIds[i]))->InsertString(j,_T(""));
			}
		((CComboBox*)GetDlgItem(iComboIds[i]))->SetCurSel(0);
		}

//*****************************************************************************

	m_cListCtrl.Create(WS_CHILD|WS_CLIPCHILDREN|WS_CLIPSIBLINGS|WS_VISIBLE|WS_BORDER|LVS_REPORT,sRect,this,IDC_LIST);
	m_cListCtrl.SetImageList(&m_cImages,LVSIL_SMALL);

	m_cListCtrl.InsertColumn(0,_T("Column 1"),LVCFMT_LEFT,200);
	m_cListCtrl.InsertColumn(1,_T("Column 2"),LVCFMT_LEFT,200);
	m_cListCtrl.InsertColumn(2,_T("Column 3"),LVCFMT_LEFT,200);

	m_cListCtrl.InsertItem( 0,_T("Line 1" ), 0);
	m_cListCtrl.InsertItem( 1,_T("Line 2" ), 1);
	m_cListCtrl.InsertItem( 2,_T("Line 3" ), 2);
	m_cListCtrl.InsertItem( 3,_T("Line 4" ), 3);
	m_cListCtrl.InsertItem( 4,_T("Line 5" ), 4);
	m_cListCtrl.InsertItem( 5,_T("Line 6" ), 5);
	m_cListCtrl.InsertItem( 6,_T("Line 7" ), 6);
	m_cListCtrl.InsertItem( 7,_T("Line 8" ), 7);
	m_cListCtrl.InsertItem( 8,_T("Line 9" ), 8);
	m_cListCtrl.InsertItem( 9,_T("Line 10"), 9);
	m_cListCtrl.InsertItem(10,_T("Line 11"),10);
	m_cListCtrl.InsertItem(11,_T("Line 12"),11);
	m_cListCtrl.InsertItem(12,_T("Line 13"),12);
	m_cListCtrl.InsertItem(13,_T("Line 14"),13);

	for(iPos=0;iPos<14;iPos++)
		{
		m_cListCtrl.SetItemText(iPos,1,_T("Text"));
		}

//*****************************************************************************
	
				m_cTreeCtrl.Create(WS_CHILD|WS_CLIPCHILDREN|WS_CLIPSIBLINGS|WS_VISIBLE|WS_BORDER|TVS_HASLINES|TVS_LINESATROOT|TVS_HASBUTTONS|WS_HSCROLL,sRect,this,IDC_TREE);
				m_cTreeCtrl.SetImageList(&m_cImages,TVSIL_NORMAL);

	hTreeItem = m_cTreeCtrl.InsertItem(_T("Entry 1"    ),1,1,TVI_ROOT);
				m_cTreeCtrl.InsertItem(_T("SubEntry 1a"),2,2,hTreeItem);
				m_cTreeCtrl.InsertItem(_T("SubEntry 1b"),3,3,hTreeItem);
				m_cTreeCtrl.InsertItem(_T("SubEntry 1c"),4,4,hTreeItem);
				m_cTreeCtrl.InsertItem(_T("SubEntry 1d ............................................................X......................................................................................................................................."),hTreeItem);
				m_cTreeCtrl.Expand(hTreeItem,TVE_EXPAND);

	hTreeItem = m_cTreeCtrl.InsertItem(_T("Entry 2"    ),1,1,TVI_ROOT);
				m_cTreeCtrl.InsertItem(_T("SubEntry 2a"),2,2,hTreeItem);
				m_cTreeCtrl.InsertItem(_T("SubEntry 2b"),3,3,hTreeItem);
				m_cTreeCtrl.InsertItem(_T("SubEntry 2c"),4,4,hTreeItem);
				m_cTreeCtrl.InsertItem(_T("SubEntry 2d ............................................................X......................................................................................................................................."),hTreeItem);
				m_cTreeCtrl.Expand(hTreeItem,TVE_EXPAND);

	hTreeItem = m_cTreeCtrl.InsertItem(_T("Entry 3"    ),1,1,TVI_ROOT);
				m_cTreeCtrl.InsertItem(_T("SubEntry 3a"),2,2,hTreeItem);
				m_cTreeCtrl.InsertItem(_T("SubEntry 3b"),3,3,hTreeItem);
				m_cTreeCtrl.InsertItem(_T("SubEntry 3c"),4,4,hTreeItem);
				m_cTreeCtrl.InsertItem(_T("SubEntry 3d ............................................................X......................................................................................................................................."),hTreeItem);
				m_cTreeCtrl.Expand(hTreeItem,TVE_EXPAND);

	

//*****************************************************************************	
	
	m_cEditCtrl.Create(WS_CHILD|WS_CLIPCHILDREN|WS_CLIPSIBLINGS|WS_VISIBLE|WS_BORDER|ES_MULTILINE|ES_WANTRETURN|WS_HSCROLL|WS_VSCROLL,sRect,this,IDC_EDIT);
	m_cEditCtrl.SetFont(CFont::FromHandle((HFONT)GetStockObject(ANSI_VAR_FONT)));
	m_cEditCtrl.SetWindowText(_T("Hello\r\n\r\nThis is a Demo Text.\r\n\r\n\r\n\r\n....................X.........................................................X......................................................X..................................................X..............\r\n\r\n"));	
	

	OnCheck(-1);



return TRUE;
}

//*****************************************************************************
//*
//*		OnSysCommand
//*
//*****************************************************************************
void CLabelCtrlDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if((nID & 0xFFF0) == IDM_ABOUTBOX)
		{
		CDialog	sDlg(IDD_ABOUTBOX);
		
		sDlg.DoModal();
		}
	else{
		CDialog::OnSysCommand(nID, lParam);
		}
}

//*****************************************************************************
//*
//*		OnPaint
//*
//*****************************************************************************
//  Wollen Sie Ihrem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie
// 	den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das
// 	Dokument/Ansicht-Modell verwenden, wird dies automatisch fr Sie erledigt.
void CLabelCtrlDlg::OnPaint()
{
	if(IsIconic())
		{
		CPaintDC dc(this);										// Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		dc.DrawIcon(x, y, m_hIcon);
		}
	else{
		CDialog::OnPaint();
		}
}

//*****************************************************************************
//*
//*		OnChangeColor?
//*
//*****************************************************************************
void CLabelCtrlDlg::OnChangeColor1(){m_cLabelCtrl.SetColor(CLW_COLOR_LABELS,aColors[((CComboBox*)GetDlgItem(IDC_COMBO1))->GetCurSel()]);}
void CLabelCtrlDlg::OnChangeColor2(){m_cLabelCtrl.SetColor(CLW_COLOR_WHITE ,aColors[((CComboBox*)GetDlgItem(IDC_COMBO2))->GetCurSel()]);}

//*****************************************************************************
//*
//*		OnQueryDragIcon
//*
//*****************************************************************************
HCURSOR CLabelCtrlDlg::OnQueryDragIcon()
{

return (HCURSOR) m_hIcon;
}

//*****************************************************************************
//*
//*		OnOK
//*
//*****************************************************************************
void CLabelCtrlDlg::OnOK()
{

	CDialog::OnOK();
}

//*****************************************************************************
//*
//*		OnCancel
//*
//*****************************************************************************
void CLabelCtrlDlg::OnCancel()
{

	CDialog::OnCancel();
}


//*****************************************************************************
//*
//*		OnRadio?
//*
//*****************************************************************************
void CLabelCtrlDlg::OnRadio1(){OnRadio(0);} 
void CLabelCtrlDlg::OnRadio2(){OnRadio(1);}  
void CLabelCtrlDlg::OnRadio3(){OnRadio(2);}  
void CLabelCtrlDlg::OnRadio(int iNum)
{

	UpdateData();
	m_cLabelCtrl.SetSel(m_iSelected);

}


//*****************************************************************************
//*
//*		OnSelChanged
//*
//*****************************************************************************
void CLabelCtrlDlg::OnSelChanged(NMHDR *pNmHdr, LRESULT *pResult)
{
LabelNotify	*pNotify=(LabelNotify*)pNmHdr;


	m_iSelected = pNotify->select;
	UpdateData(FALSE);

}

//*****************************************************************************
//*
//*		OnDrawItem
//*
//*****************************************************************************
void CLabelCtrlDlg::OnDrawItem(int nIDCtl,LPDRAWITEMSTRUCT pDrawItemStruct) 
{
unsigned	uId;



	uId = GetWindowLong(pDrawItemStruct->hwndItem,GWL_ID);

	if(pDrawItemStruct->itemID<=0)
		{
		SetBkColor  (pDrawItemStruct->hDC,GetSysColor(COLOR_WINDOW));
		SetTextColor(pDrawItemStruct->hDC,GetSysColor(COLOR_WINDOWTEXT));
		ExtTextOut  (pDrawItemStruct->hDC,3,3,ETO_OPAQUE,&pDrawItemStruct->rcItem,_T(" default"),8,NULL);
		}
	else{
		SetBkColor(pDrawItemStruct->hDC,aColors[pDrawItemStruct->itemID]);
		ExtTextOut(pDrawItemStruct->hDC,0,0,ETO_OPAQUE,&pDrawItemStruct->rcItem,NULL,0,NULL);
		}

}


//*****************************************************************************
//*
//*		OnCheck?
//*
//*****************************************************************************
void CLabelCtrlDlg::OnCheck1(){OnCheck(0);}
void CLabelCtrlDlg::OnCheck2(){OnCheck(1);} 
void CLabelCtrlDlg::OnCheck3(){OnCheck(2);} 
void CLabelCtrlDlg::OnCheck4(){OnCheck(3);} 
void CLabelCtrlDlg::OnCheck5(){OnCheck(4);} 
void CLabelCtrlDlg::OnCheck6(){OnCheck(5);} 
void CLabelCtrlDlg::OnCheck7(){OnCheck(6);} 
void CLabelCtrlDlg::OnCheck8(){OnCheck(7);} 
void CLabelCtrlDlg::OnCheck(int iNum)
{
LPCTSTR	    aLabelNames[3]={_T("List-Contol"),_T("Tree-Conrol"),_T("Editbox")};	
CWnd	   *pWndList[3];
CWnd       *pWnd;
CRect		sRect;
POINT		sPoint;
int			iSize;
int			iTop;


	if(iNum==0)m_dwFlags ^= CLW_WHITELINE;					// Eine weise Linie ziehnen
	if(iNum==1)m_dwFlags ^= CLW_SCROLLBAR;					// H-Scrollbar
	if(iNum==2)m_dwFlags ^= CLW_FRAMETOP;					// Rahmen Optionen
	if(iNum==3)m_dwFlags ^= CLW_FRAMEBOTTOM;				//			*
	if(iNum==4)m_dwFlags ^= CLW_FRAMELEFT;					//			*
	if(iNum==5)m_dwFlags ^= CLW_FRAMERIGHT;					//			*
	if(iNum==6)m_dwFlags ^= CLW_CHILD;						// Automatische Umschaltung auf Kindfenster
	if(iNum==7)m_dwFlags ^= CLW_CHILDSCROLLOFF;				// Scrollbar abschaltbar


	((CButton*)GetDlgItem(IDC_CHECK1))->SetCheck((m_dwFlags&CLW_WHITELINE     )? 1:0);
	((CButton*)GetDlgItem(IDC_CHECK2))->SetCheck((m_dwFlags&CLW_SCROLLBAR     )? 1:0);
	((CButton*)GetDlgItem(IDC_CHECK3))->SetCheck((m_dwFlags&CLW_FRAMETOP      )? 1:0);
	((CButton*)GetDlgItem(IDC_CHECK4))->SetCheck((m_dwFlags&CLW_FRAMEBOTTOM   )? 1:0);
	((CButton*)GetDlgItem(IDC_CHECK5))->SetCheck((m_dwFlags&CLW_FRAMELEFT     )? 1:0);
	((CButton*)GetDlgItem(IDC_CHECK6))->SetCheck((m_dwFlags&CLW_FRAMERIGHT    )? 1:0);
	((CButton*)GetDlgItem(IDC_CHECK7))->SetCheck((m_dwFlags&CLW_CHILD         )? 1:0);
	((CButton*)GetDlgItem(IDC_CHECK8))->SetCheck((m_dwFlags&CLW_CHILDSCROLLOFF)? 1:0);

	sPoint.x = 0;
	sPoint.y = 0;

	pWnd =GetDlgItem(IDC_FRAME);
	pWnd->GetWindowRect (&sRect );
		  ClientToScreen(&sPoint);

	sRect.left	   -= sPoint.x;
	sRect.right    -= sPoint.x;
	sRect.top	   -= sPoint.y;
	sRect.bottom   -= sPoint.y;


	if(IsWindow(m_cLabelCtrl.m_hWnd))
		{
		m_cLabelCtrl.DestroyWindow();
		}

	if(m_dwFlags&CLW_CHILD)
		{
		GetDlgItem(IDC_INFO)->ShowWindow(SW_HIDE);
		m_cListCtrl.ShowWindow(SW_HIDE);
		m_cTreeCtrl.ShowWindow(SW_HIDE);
		m_cEditCtrl.ShowWindow(SW_HIDE);

		m_cListCtrl.MoveWindow(sRect.left+sRect.Width()/3*0,sRect.top,sRect.Width()/3,sRect.Height()/2);
		m_cTreeCtrl.MoveWindow(sRect.left+sRect.Width()/3*1,sRect.top,sRect.Width()/3,sRect.Height()/2);
		m_cEditCtrl.MoveWindow(sRect.left+sRect.Width()/3*2,sRect.top,sRect.Width()/3,sRect.Height()/2);
		
		GetDlgItem(IDC_CHECK8)->EnableWindow(TRUE);
		}
	else{
		GetDlgItem(IDC_INFO)->ShowWindow(SW_SHOW);
		m_cListCtrl.ShowWindow(SW_HIDE);
		m_cTreeCtrl.ShowWindow(SW_HIDE);
		m_cEditCtrl.ShowWindow(SW_HIDE);
		
		m_cListCtrl.MoveWindow(sRect.left+sRect.Width()/3*0,sRect.top,sRect.Width()/3,sRect.Height()/2);
		m_cTreeCtrl.MoveWindow(sRect.left+sRect.Width()/3*1,sRect.top,sRect.Width()/3,sRect.Height()/2);
		m_cEditCtrl.MoveWindow(sRect.left+sRect.Width()/3*2,sRect.top,sRect.Width()/3,sRect.Height()/2);

		GetDlgItem(IDC_CHECK8)->EnableWindow(FALSE);
		}
	
	iSize			= GetSystemMetrics(SM_CYHSCROLL)+3;
	iTop			= sRect.top;
	sRect.top		= sRect.bottom-iSize;							
					 
	pWndList[0]		= &m_cListCtrl;
	pWndList[1] 	= &m_cTreeCtrl;
	pWndList[2] 	= &m_cEditCtrl;

	m_cLabelCtrl.Create(3,0,aLabelNames,pWndList,sRect,this,WS_CHILD|WS_CLIPCHILDREN|WS_CLIPSIBLINGS|WS_VISIBLE|m_dwFlags,IDC_LABEL);

	sRect.top		= iTop;
	sRect.bottom   -= iSize;
	m_cLabelCtrl.SetChildRect(sRect);


	m_cLabelCtrl.RedrawWindow();
	RedrawWindow(NULL,NULL,RDW_INVALIDATE|RDW_UPDATENOW|RDW_ERASE|RDW_ALLCHILDREN);


}


